/**
 * Bevat alle lidmaatschapdetails voor één club.
 * 
 * Voorlopig nemen we aan dat er hoogstens 100 leden
 * tot de club kunnen behoren.
 */
public class Club {
    
    private int aantalLeden;
    
    private Lidmaatschap[] tab;
    
    // maximaal aantal leden (kleiner maken om te testen!)
    private static final int MAX = 100;
    
    /**
     * Nieuwe club, zonder leden
     */
    public Club() {
        aantalLeden = 0;
        tab = new Lidmaatschap[MAX];
    }

    /**
     * Voeg een nieuw lidmaatschap toe
     */
    public void maakLid(Lidmaatschap lidmaatschap) {
        // eigenlijk zou je hier ook moeten testen of het
        // aantalLeden niet gelijk is aan MAX...
        tab[aantalLeden] = lidmaatschap;
        aantalLeden ++;
    }
    
    /**
     * Voeg een nieuw lidmaatschap toe
     */
    public void maakLid(String naam, int maand, int jaar) {
        maakLid (new Lidmaatschap (naam, maand, jaar));
    }
     
    /**
     * Aantal leden
     */
    public int getAantalLeden() {
        return aantalLeden;
    }
    
    /**
     * Aantal leden ingeschreven in een bepaalde
     * maand en een bepaald jaar
     */
    public int getAantalLeden (int maand, int jaar) {
        int aantal = 0;
        for (int i=0; i < aantalLeden; i++) {
            Lidmaatschap lms = tab[i];
            if (maand == lms.getMaand() && jaar == lms.getJaar()) {
              aantal++;
            }
        }
        return aantal;
    }
    
    // hulpmethode: verwijdert lid met opgegeven
    // positie uit de array met leden
    private void verwijder (int pos) {
        // 
        for (int i=pos+1; i < aantalLeden; i++) {
            tab[i-1] = tab[i];
        }
        aantalLeden --;
        
        /* alternatief: laatste element verplaatsen
           naar pos - is eigenlijk veel beter
        aantalLeden --;
        tab[pos] = tab[aantalLeden];
        */
    }
    
    /**
     * Verwijder alle leden de zijn ingeschreven
     * in een bepaalde maand en een bepaald jaar
     */
    public void verwijderLeden (int maand, int jaar) {
        // hier liever geen for-lus gebruiken. Teller wordt niet
        // altijd met 1 verhoogd.
        int i=0; 
        while (i < aantalLeden) {
           Lidmaatschap lms = tab[i];
           if (maand == lms.getMaand() && jaar == lms.getJaar()) {
              verwijder (i);
           } else {
              i++;    
           }
        }
        
        // Nadenkertje! Kan efficiënter, zonder gebruik van hulpmethode
    }
    
}

