import java.util.Random;

/**
 * Deze klasse bevat enkele methoden waarmee de rest van het programma
 * kunt testen.
 */
public class Clubtester {
        
    private static final Random RG = new Random ();
    
    private static final String[] NAMEN = 
        { "Bart", "Piet", "Ann", "Mieke", "Els",
          "Koen", "Emma", "Louise", "Fred", "Leen",
          "Jan", "Johan", "Charlotte", "Ria", "Karel",
          "Alain", "Bea", "Rudy", "Lieve", "Gert"
        };
    
    /**
     * Genereert een 'willekeurige' naam
     */
    private String willekeurigeNaam () {
        return NAMEN[RG.nextInt(NAMEN.length)];
    }
    
    /**
     * Genereert een 'willekeurig' lidmaatschap
     * jaar: 2013 of 2014
     * maand: 1..12
     * naam: willekeurig
     */
    private Lidmaatschap willekeurigLidmaatschap () {
        return new Lidmaatschap (
             willekeurigeNaam(),
             RG.nextInt(12) + 1,
             RG.nextInt(2) + 2013
        );    
    }
    
    /**
     * Creëert een nieuw Club-object met een gegeven aantal 
     * 'willekeurige' leden
     */
    public Club maakClub (int aantalLeden) {
        Club club = new Club();
        for (int i=0; i < aantalLeden; i++) {
            club.maakLid(willekeurigLidmaatschap());
        }
        return club;
    }
    
}
